<template>
    <div class="the-edit-bar-table-controls" style="position: relative">
        <table-button :editor="props.editor" />
        <div ref="popup" v-if="show" style="position: absolute; z-index: 1000; top: 100%; right: 0;" tabindex="1"
            @focusout="checkIfShouldClose">
            <div v-for="(row, y) in table_highlight" style="display: flex; flex-direction: column; height: 20px"
                :key="y">
                <div style="display: flex;">
                    <button type="button" @click="createTable(x + 1, y + 1)" v-for="(b, x) in row" :key="x"
                        @focus="() => { reset(); highlight(x, y) }" @mouseenter="highlight(x, y)" @mouseleave="reset"
                        class="the-table-init-button" :class="{ highlight: b == 1 }" :title="`${x + 1}x${y + 1}`">
                    </button>
                </div>
            </div>
        </div>
        <!-- <bubble-menu class="the-editor-bubble-menu" :editor="editor" plugin-key="table-bubble" :should-show="shouldShowMergeTools">
            <div style="display: flex">
                <merge-cells :editor="editor" />
                <split-cells :editor="editor" />
                <toggle-header-cell :editor="editor" />
            </div>
        </bubble-menu> -->
        <bubble-menu class="the-editor-bubble-menu the-editor-table-bubble-menu" :editor="editor" :tippy-options="bubbleOptions"
            plugin-key="table-bubble-cell" :should-show="shouldShowCellTools">
            <div style="display: flex; flex-direction: column;">
                <add-col-before class="the-editor-bubble-menu-button" :editor="editor" />
                <add-col-after class="the-editor-bubble-menu-button" :editor="editor" />
                <add-row-before class="the-editor-bubble-menu-button" :editor="editor" />
                <add-row-after class="the-editor-bubble-menu-button" :editor="editor" />
                <toggle-header-cell class="the-editor-bubble-menu-button" :editor="editor" />
                <merge-cells class="the-editor-bubble-menu-button" :editor="editor" />
                <split-cells class="the-editor-bubble-menu-button" :editor="editor" />
                <delete-col class="the-editor-bubble-menu-button" :editor="editor" />
                <delete-row class="the-editor-bubble-menu-button" :editor="editor" />
            </div>
        </bubble-menu>
    </div>
    <!-- <div v-if="extra_table_tools" class="the-edit-bar-button-group">
            <delete-col :editor="editor" />
            <add-col-before :editor="editor" />
            <add-col-after :editor="editor" />
            <delete-row :editor="editor" />
            <add-row-before :editor="editor" />
            <add-row-after :editor="editor" />
    </div> -->

</template>

<script lang="ts" setup>
import { reactive, ref, nextTick } from 'vue'
import { BubbleMenu } from '@tiptap/vue-3';
import makeButton from '../makeButton';
import makeIcon from '../makeIcon';
import { Props as TippyProps } from 'tippy.js'
import {isNodeActive} from '@tiptap/core'
import type { TheEditor } from '../TheEditor';
import { Editor } from '@tiptap/core';

const props = defineProps<{
    editor: TheEditor,
}>()

const popup = ref<HTMLElement>()
const show = ref(false)
// const extra_table_tools = computed(()=>props.editor.can().addColumnAfter())

const TableButton = makeButton({
    title: 'create table',
    content: makeIcon('table'),
    active: _ed => false,
    enabled: ed => ed.can().insertTable(),
    action: _ed => {
        show.value = !show.value
        if (show.value) {
            nextTick(() => popup.value?.focus())
        }
    },
})

const MergeCells = makeButton({
    title: 'merge cells',
    content: makeIcon('tableMergeCells', { viewBox: '0 0 24 24' }),
    active: _ed => false,
    enabled: ed => ed.can().mergeCells(),
    action: ed => ed.chain().focus().mergeCells().run(),
})

const SplitCells = makeButton({
    title: 'split cells',
    content: makeIcon('tableSplitCell', { viewBox: '0 0 24 24' }),
    active: _ed => false,
    enabled: ed => ed.can().splitCell(),
    action: ed => ed.chain().focus().splitCell().run(),
})

const AddRowAfter = makeButton({
    title: 'add row after selection',
    content: makeIcon('tableAddRowAfter', { viewBox: '0 0 24 24' }),
    active: _ed => false,
    enabled: ed => ed.can().addRowAfter(),
    action: ed => ed.chain().focus().addRowAfter().run(),
})

const AddRowBefore = makeButton({
    title: 'add row before selection',
    content: makeIcon('tableAddRowBefore', { viewBox: '0 0 24 24' }),
    active: _ed => false,
    enabled: ed => ed.can().addRowAfter(),
    action: ed => ed.chain().focus().addRowAfter().run(),
})

const AddColAfter = makeButton({
    title: 'add column after selection',
    content: makeIcon('tableAddColumnAfter', { viewBox: '0 0 24 24' }),
    active: _ed => false,
    enabled: ed => ed.can().addColumnAfter(),
    action: ed => ed.chain().focus().addColumnAfter().run(),
})

const AddColBefore = makeButton({
    title: 'add column before selection',
    content: makeIcon('tableAddColumnBefore', { viewBox: '0 0 24 24' }),
    active: _ed => false,
    enabled: ed => ed.can().addColumnBefore(),
    action: ed => ed.chain().focus().addColumnBefore().run(),
})

const DeleteRow = makeButton({
    title: 'delete selected row(s)',
    content: makeIcon('tableDeleteRow', { viewBox: '0 0 24 24' }),
    active: _ed => false,
    enabled: ed => ed.can().deleteRow(),
    action: ed => ed.chain().focus().deleteRow().run(),
})

const DeleteCol = makeButton({
    title: 'delete selected column(s)',
    content: makeIcon('tableDeleteColumn', { viewBox: '0 0 24 24' }),
    active: _ed => false,
    enabled: ed => ed.can().deleteColumn(),
    action: ed => ed.chain().focus().deleteColumn().run(),
})
const ToggleHeaderCell = makeButton({
    title: 'toggle header',
    content: makeIcon('tableToggleHeaderCell', { viewBox: '0 0 24 24' }),
    active: _ed => false,
    enabled: ed => ed.can().toggleHeaderCell(),
    action: ed => ed.chain().focus().toggleHeaderCell().run(),
})


const shouldShowCellTools = (ed: { editor: Editor, from: number, to: number }) => {
    // const currentSelection = ed.editor.view.state.selection;
    // const json = currentSelection.toJSON()
    // if (!(json.type === 'cell')) return false
    // if (json.anchor !== json.head) show_merge_tools.value = true
    // return true
    // return props.editor.can().addColumnAfter()
    return isNodeActive(ed.editor.view.state, 'table')
}


const checkIfShouldClose = (e: FocusEvent) => {
    if (e.relatedTarget === null || !popup.value?.contains(e.relatedTarget as Node)) {
        show.value = false
    }
}

const bubbleOptions: Partial<TippyProps> = {
    placement: 'right',
    getReferenceClientRect: () => {
        // return props.editor.view.dom.getBoundingClientRect()
        const { state, view } = props.editor;
        const { selection } = state;
        const { $from } = selection;

        // // Get the dom element of the current selection
        // const sel = $from.pos - 1;

        // let node = props.editor.view.domAtPos(sel).node as HTMLElement

        // while (node && node.tagName !== 'TABLE') {
        //     node = node.parentNode as HTMLElement
        // }
        // console.log(node)

        // if (node.tagName !== 'TABLE') return props.editor.view.dom.getBoundingClientRect()

        // let rect = node.getBoundingClientRect()

        // // This is fine as long as the table isn't taller than the window
        // // but if the table IS taller than the window, our popup will be offscreen...
        
        // return rect

        // get the client rect of the whole editor
        // Get the cell our selection is in
        let cursor_node = view.domAtPos(selection.from).node as HTMLElement
        let current_node_rect 

        if (['TD', 'TH'].includes(cursor_node.tagName)) current_node_rect = cursor_node.getBoundingClientRect()
        else {
            let cell = view.domAtPos($from.before()).node as HTMLElement
            current_node_rect = cell.getBoundingClientRect()
        }
        
        let editor_rect = props.editor.view.dom.getBoundingClientRect()

        // Should we show the bubble inside the editor or to thr right of it?
        let inside = (window.innerWidth - editor_rect.width) < 50
        // Create a new rect using the top/bottom of the selection and the left of the editor
        let rect = {
            top: current_node_rect.top,
            bottom: current_node_rect.bottom,
            left: editor_rect.left,
            right: editor_rect.right,
            width: editor_rect.width - (inside? 30 : 0),
            height: current_node_rect.height
        }
        return new DOMRect(rect.left, rect.top, rect.width, rect.height)
    }
}

const table_highlight = reactive([
    [0, 0, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 0],
])

const createTable = (width: number, height: number) => {
    props.editor.chain().focus().insertTable({ rows: height, cols: width }).run()
}

const highlight = (x: number, y: number) => {
    for (let i = 0; i < y + 1; i++) {
        for (let j = 0; j < x + 1; j++) {
            table_highlight[i][j] = 1
        }
    }
}
const reset = () => {
    table_highlight.forEach((x, i) => x.forEach((_, j) => table_highlight[i][j] = 0))
}
</script>

<style lang="css" scoped>
.the-table-init-button {
    width: 20px;
    height: 20px;
    background-color: white;
    border: 1px solid #c4c4c4;
    outline: none;
    margin: 0;

}

.the-table-init-button.highlight {
    background-color: rgb(118, 118, 188);
}
</style>
